window.onload = function()
{
    normalTextarea = true;
    WikiwygHasBeenVisible = false;

    if (! Wikiwyg.browserIsSupported)
    {
        ewiki_NormalTextarea();
    }
        
    // Subclassing Wikiwyg
    proto = Subclass("Wikiwyg.ewiki", "Wikiwyg");
    proto.modeClasses = 
    [
        "Wikiwyg.Wysiwyg.ewiki",
        "Wikiwyg.Wikitext.ewiki",
        "Wikiwyg.Preview"
    ];
    
    proto.editMode = function()
    {
        // As opposed to the super function this function doesn't
        // use the div's html input. Rather ewiki's textarea which
        // holds the WikiSource is used.
        
        this.current_mode = this.first_mode;
        this.toolbarObject.resetModeSelector();
        this.current_mode.enableThis();
        
        this.fromWikiText(document.getElementById("ewiki_content").value);
        normalTextarea = false;
    }
    
    proto.onSubmit = function()
    {
        // This function takes the Wikitext and posts it to ewiki's deault textarea.
        // This way only minimal changes to ewiki are necessary.
        
        if (! Wikiwyg.browserIsSupported) { return; }
        if (normalTextarea) { return; }

        if (this.current_mode == this.mode_objects["Wikiwyg.Wikitext.ewiki"])
        {
            // WIKITEXT
            document.getElementById("ewiki_content").value = this.current_mode.textarea.value;
        }
        
        else if (this.current_mode == this.mode_objects["Wikiwyg.Wysiwyg.ewiki"])
        {
            // WYSIWYG
            document.getElementById("ewiki_content").value = this.mode_objects["Wikiwyg.Wikitext.ewiki"].convert_html_to_wikitext(this.current_mode.get_inner_html());
        }
        
        else if (this.current_mode == this.mode_objects["Wikiwyg.Preview"])
        {
            // PREVIEW
            document.getElementById("ewiki_content").value = this.mode_objects["Wikiwyg.Wikitext.ewiki"].convert_html_to_wikitext(this.current_mode.div.innerHTML);
        }
    }
    
    proto.fromWikiText = function(text)
    {
        // This function updates Wikiwyg's contents from any given Wikitext.
        
        if (! Wikiwyg.browserIsSupported) { return; }
        
        this.mode_objects["Wikiwyg.Wikitext.ewiki"].area.value = text;
        this.mode_objects["Wikiwyg.Wysiwyg.ewiki"].get_edit_document().body.innerHTML = this.mode_objects["Wikiwyg.Wikitext.ewiki"].convert_wikitext_to_html(text);
        this.mode_objects["Wikiwyg.Preview"].div.innerHTML = this.mode_objects["Wikiwyg.Wikitext.ewiki"].convert_wikitext_to_html(text);
    }

    proto1 = Subclass("Wikiwyg.Wikitext.ewiki", "Wikiwyg.Wikitext");
    
    proto1.add_markup_words_sizetags = function(markup_start, markup_finish, example, remove_array)
    {
        var rm_markup;
        var rm_markup_start;
        var rm_markup_finish;
        
        for (var i = 0; i < remove_array.length; i++)
        {
            rm_markup = this.config.markupRules[remove_array[i]];
            rm_markup_start = rm_markup[1];
            rm_markup_finish = rm_markup[2];
            
            if (rm_markup_start == "undefined") { rm_markup_start = ""; }
            if (rm_markup_finish == "undefined") {rm_markup_finish = ""; }

            if (this.toggle_same_format(rm_markup_start, rm_markup_finish))
            {
                this.selection_end = this.selection_end - (rm_markup_start.length + rm_markup_finish.length);
            
                rm_markup_start = '';
                rm_markup_finish = '';
            }
        }
        
        
        if (this.toggle_same_format(markup_start, markup_finish))
        {
            this.selection_end = this.selection_end - (markup_start.length + markup_finish.length);
            
            markup_start = '';
            markup_finish = '';
        }
        
        if (this.sel.length == 0)
        {
            if (example)
                this.sel = example;
                
            var text = this.start + markup_start + this.sel + markup_finish + this.finish;
            var start = this.selection_start + markup_start.length;
            var end = this.selection_end + markup_start.length + this.sel.length;
            
            this.set_text_and_selection(text, start, end);
        }
        
        else
        {
            var text = this.start + markup_start + this.sel + markup_finish + this.finish;
            var start = this.selection_start;
            var end = this.selection_end + markup_start.length + markup_finish.length;
            
            this.set_text_and_selection(text, start, end);
        }
        
        this.area.focus();
    }
    
    proto1.markup_bound_phrase_sizetags = function(markup_array, remove_array)
    {
        var markup_start = markup_array[1];
        var markup_finish = markup_array[2];
        var scroll_top = this.area.scrollTop;
        
        if (markup_finish == 'undefined')
            markup_finish = markup_start;
            
        if (this.get_words())
            this.add_markup_words_sizetags(markup_start, markup_finish, null, remove_array);
            
        this.area.scrollTop = scroll_top;
    }
    
    proto1.make_do_sizetags = function(style, remove_array)
    {
        return function()
        {
            var markup = this.config.markupRules[style];
            var handler = markup[0];
            if (! this['markup_' + handler + "_sizetags"])
                die('No handler for markup: "' + handler + '"');
            this['markup_' + handler + "_sizetags"](markup, remove_array);
        }
    }
    
    proto1.config = Wikiwyg.Wikitext.prototype.config;
    proto1.config.markupRules.link =       ["undefined",    "",      ""];  // DES
    proto1.config.markupRules.bold =       ["bound_phrase", "**",    "**"];
    proto1.config.markupRules.code =       ["bound_phrase", "==",    "=="];
    proto1.config.markupRules.italic =     ["bound_phrase", "''",    "''"];
    proto1.config.markupRules.underline =  ["bound_phrase", "__",    "__"]; // DES
    proto1.config.markupRules.strike =     ["bound_phrase", "--",    "--"];    // DES
    proto1.config.markupRules.p =          ["bound_phrase",  "",      "\n\n"]; // DES
    proto1.config.markupRules.pre =        ["bound_phrase", "==",    "=="];
    proto1.config.markupRules.h1 =         ["start_line",   "!!! ",  ""];
    proto1.config.markupRules.h2 =         ["start_line",   "!! ",   ""];
    proto1.config.markupRules.h3 =         ["start_line",   "! ",    ""];
    proto1.config.markupRules.ordered =    ["start_lines",  "# ",    ""];
    proto1.config.markupRules.unordered =  ["start_lines",  "~ ",    ""];
  //proto1.config.markupRules.indent =     ["start_lines",  "> ",    ""];  // This seems to be hard-coded in Wikiwyg
    proto1.config.markupRules.indent =     ["undefined",    "",      ""];  // DES
    proto1.config.markupRules.hr =         ["line_alone",   "----",  ""];              // DES
    proto1.config.markupRules.table =      ["line_alone",   "|A |B |C |\n||||\n||||", ""];
    
    // WikiBerd-specific additional tags
    proto1.config.markupRules.squarelist = ["start_lines",  "-",     ""];
    proto1.config.markupRules.circlelist = ["start_lines",  "+",     ""];
    proto1.config.markupRules.bold1 =      ["bound_phrase", "'''",   "'''"];
    proto1.config.markupRules.sup =        ["bound_phrase", "^^",    "^^"];
    proto1.config.markupRules.sub =        ["bound_phrase", "_-",     "_-"];
    proto1.config.markupRules.big =        ["bound_phrase", "}}",    "}}"];
    proto1.config.markupRules.small =      ["bound_phrase", "{{",    "{{"];
    proto1.config.markupRules.normal =     ["bound_phrase", "",    ""];
    
    proto1.do_squarelist = Wikiwyg.Wikitext.make_do("squarelist");
    proto1.do_circlelist = Wikiwyg.Wikitext.make_do("circlelist");
    proto1.do_bold1 =      Wikiwyg.Wikitext.make_do("bold1");
    proto1.do_sup =        Wikiwyg.Wikitext.make_do("sup");
    proto1.do_sub =        Wikiwyg.Wikitext.make_do("sub");
    proto1.do_big =        proto1.make_do_sizetags("big", ["small"]);  // Do Big, Contradicts Small
    proto1.do_small =      proto1.make_do_sizetags("small", ["big"]);  // Do Small, Contradicts Big
    proto1.do_normal =     proto1.make_do_sizetags("normal", ["big", "small", "big"]); // Do Normal, Contradicts Big and Small
                                                                                       // Note the crude hack to make the for loop below working under all circumstances

    proto1.convertWikitextToHtml = function(wikitext, func)
    {
        this.copyhtml = this.convert_wikitext_to_html(wikitext);
        func(this.copyhtml);
    }
    
    proto1.escape_for_regex = function(text)
    {
        text = text.replace(/\\/g, "\\");
        text = text.replace(/\[/g, "\\[");
        text = text.replace(/\]/g, "\\]");
        text = text.replace(/\^/g, "\\^");
        text = text.replace(/\-/g, "\\-");
        text = text.replace(/\//g, "\\/");
        text = text.replace(/\*/g, "\\*");
        text = text.replace(/\+/g, "\\+");
        text = text.replace(/\$/g, "\\$");
        text = text.replace(/\?/g, "\\?");
        text = text.replace(/\./g, "\\.");
        text = text.replace(/\(/g, "\\(");
        text = text.replace(/\)/g, "\\)");
        text = text.replace(/\{/g, "\\{");
        text = text.replace(/\}/g, "\\}");
        text = text.replace(/\:/g, "\\:");
        text = text.replace(/\|/g, "\\|");
        text = text.replace(/\,/g, "\\,");
        text = text.replace(/\!/g, "\\!");
        text = text.replace(/\s/g, "\\s");
        return text;
    }
    
    proto1.replace_line = function(text, src, dst)
    {
        src = this.escape_for_regex(src);
        
        myRegExp = new RegExp("^\\s*" + src + "\\s*$","m");
        
        while (myRegExp.test(text))
        {
            text = text.replace(myRegExp, dst);
        }
        
        return text;
    }
    
    proto1.markup_lines = function(text, wikiTag, htmlTag1, htmlTag2, htmlTag3, htmlTag4)
    {   
        wikiTag = this.escape_for_regex(wikiTag);

        /*
        var reLine       = new RegExp("^\\s*" + wikiTag + "\\s+[^\\r\\n]*$", "m");
        var reRemWikiTag = new RegExp("^\\s*" + wikiTag + "\\s+", "m");
        var reBlock      = new RegExp("(?:^\\s*" + wikiTag + "\\s+[^\\r\\n]*[\\r\\n])+", "m");
        */
        
        var reLine       = new RegExp("^\\s*" + wikiTag + "\\s*[^\\r\\n]*$", "m");
        var reRemWikiTag = new RegExp("^\\s*" + wikiTag + "\\s*", "m");
        var reBlock      = new RegExp("(?:^\\s*" + wikiTag + "\\s*[^\\r\\n]*[\\r\\n]*)+", "m");
        var reEmptyLine  = new RegExp("(^$)+", "gm");
        
        var text1 = "";
        var Block;
        var Line;
        
        var pos;
        
        // Tag blocks
        if ((htmlTag1 != "") | (htmlTag2 != ""))
        {
            while (reBlock.test(text))
            {
                pos = text.search(reBlock);
                
                Block = text.match(reBlock)[0];
                text1 = text1 + text.slice(0, pos) + "\n" + htmlTag1 + "\n" + Block + "\n" + htmlTag2 + "\n";
                
                while (reEmptyLine.test(text1))
                {
                    // Replacing empty lines with something useless since we can't easily remove empty lines.
                    // Otherwise we'd get broken paragraphs later on.
                    text1 = text1.replace(reEmptyLine, "<span/>");
                }
                
                text = text.slice((pos + Block.length), text.length);
            }
            
            if (text1 != "")  { text = text1 + text; }
        }
        
        // Tag individual lines
        while (reLine.test(text))
        {
            Line = text.match(reLine)[0];
            Line = Line.replace(reRemWikiTag, "");
            text = text.replace(reLine, htmlTag3 + Line + htmlTag4);
        }
        
        return text;
    }
    
    proto1.replace_bounds = function(text, wikiTag1, wikiTag2, htmlTag1, htmlTag2, htmlTag3, htmlTag4)
    {   
        wikiTag1 = this.escape_for_regex(wikiTag1);
        wikiTag2 = this.escape_for_regex(wikiTag2);

        reStart = new RegExp(wikiTag1);
        reEnd   = new RegExp(wikiTag2);
        
        while (reStart.test(text) | reEnd.test(text))
        {
            text = text.replace(reStart, htmlTag1 + htmlTag3);
            text = text.replace(reEnd,   htmlTag4 + htmlTag2);
        }
        
        return text;
    }
    
    proto1.pack_paragraphs = function(text)
    {
        var reEmptyLines = new RegExp("(^$)+", "gm");
        var reEmptyPars  = new RegExp("<p>\n</p>", "gm");
        
        text = "<p>\n" + text + "\n</p>";
        while (reEmptyLines.test(text))
        {
            text = text.replace(reEmptyLines, "</p>\n<p>");
        }
        
        while (reEmptyPars.test(text))
        {
            text = text.replace(reEmptyPars, "");
        }

        return text;
    }
    
    proto1.create_tables = function(text)
    {
        var reTableBlock = new RegExp("(?:[\\s]*\\|([^\\|\\n\\r]*\\|)+[\\s]*$)+", "m");
        var reTableLine  = new RegExp("^[\\s]*\\|([^\\|\\n\\r]*\\|)+[\\s]*$", "m");

        var Block = "";
        var Line = "";
        var Fields;
        var i = 0;
        
        while (reTableBlock.test(text))
        {
            Block = text.match(reTableBlock)[0];
            
            while (reTableLine.test(Block))
            {
                Line = Block.match(reTableLine)[0];
                Fields = Line.split("\|");
                Line = "";
                
                for(i = 1; i < (Fields.length - 1); i++)
                {
                    Line = Line + "<td>" + Fields[i] + "</td>";
                }
                
                Block = Block.replace(reTableLine, "<tr>" + Line + "</tr>");
            }

            // Formating the table here is ugly. But it's the only reliable way to make the borders visible.
            text = text.replace(reTableBlock, '<table border="1" bordercolor="#000000">\n' + Block + "\n</table>");
        }
        
        return text;
    }
    
    proto1.convert_wikitext_to_html = function(wikitext)
    {
        var html = wikitext;
        var i;
        
        // For this to work proto1.config.markupRiles.XXX needs to be an array with at least 3 entries.
        // Fill up, if there are not enough entries. It won't hurt.
        // Tables cannot be in here.
        var all_tags = [
            // ["Line Type", "Start tag", "End tag, if any", "HTML Start tag", "HTML End tag, if any", "HTML Start tag per line, if any", "HTML End tag per line, if any"],
           // DES: Don't do links for WikiBerd!
          //[this.config.markupRules.link[0],      this.config.markupRules.link[1],      this.config.markupRules.link[2],      "<a>",              "</a>",      "",     ""],
            [this.config.markupRules.bold[0],      this.config.markupRules.bold[1],      this.config.markupRules.bold[2],      "<b>",              "</b>",      "",     ""],
          //[this.config.markupRules.code[0],      this.config.markupRules.code[1],      this.config.markupRules.code[2],      "<tt>",             "</tt>",     "",     ""],
            [this.config.markupRules.italic[0],    this.config.markupRules.italic[1],    this.config.markupRules.italic[2],    "<i>",              "</i>",      "",     ""],
            [this.config.markupRules.underline[0], this.config.markupRules.underline[1], this.config.markupRules.underline[2], "<u>",              "</u>",      "",     ""],
            [this.config.markupRules.strike[0],    this.config.markupRules.strike[1],    this.config.markupRules.strike[2],    "<strike>",         "</strike>", "",     ""],
            [this.config.markupRules.pre[0],       this.config.markupRules.pre[1],       this.config.markupRules.pre[2],       "<pre>",            "</pre>",    "",     ""],
            [this.config.markupRules.h1[0],        this.config.markupRules.h1[1],        this.config.markupRules.h1[2],        "",                 "",          "<h1>", "</h1>"],
            [this.config.markupRules.h2[0],        this.config.markupRules.h2[1],        this.config.markupRules.h2[2],        "",                 "",          "<h2>", "</h2>"],
            [this.config.markupRules.h3[0],        this.config.markupRules.h3[1],        this.config.markupRules.h3[2],        "",                 "",          "<h3>", "</h3>"],
            [this.config.markupRules.h4[0],        this.config.markupRules.h4[1],        this.config.markupRules.h4[2],        "",                 "",          "<h4>", "</h4>"],
            [this.config.markupRules.h5[0],        this.config.markupRules.h5[1],        this.config.markupRules.h5[2],        "",                 "",          "<h5>", "</h5>"],
            [this.config.markupRules.h6[0],        this.config.markupRules.h6[1],        this.config.markupRules.h6[2],        "",                 "",          "<h6>", "</h6>"],
            [this.config.markupRules.ordered[0],   this.config.markupRules.ordered[1],   this.config.markupRules.ordered[2],   "<ol>",             "</ol>",     "<li>", "</li>"],
            [this.config.markupRules.unordered[0], this.config.markupRules.unordered[1], this.config.markupRules.unordered[2], '<ul type="disc">', "</ul>",     "<li>", "</li>"],
            [this.config.markupRules.hr[0],        this.config.markupRules.hr[1],        this.config.markupRules.hr[2],        "<hr/>",            "",          "",     ""],
            //[this.config.markupRules.indent[0],    this.config.markupRules.indent[1],    this.config.markupRules.indent[2],    '<div style="margin-left:15px;" class="indent">', "</div>", "", ""],
            // Paragraphs and tables mustn't be mentioned here.
                        
            // WikiBerd-specific tags
            ["start_lines", "- ",     "",      '<ul type="square">', "</ul>",    "<li>", "</li>"],
            ["start_lines", "+ ",     "",      '<ul type="circle">', "</ul>",    "<li>", "</li>"],
            ["bound_phrase", "'''''", "'''''", "<b><i>",             "</i></b>", "",     ""],
            ["bound_phrase", "'''",   "'''",   "<b>",                "</b>",     "",     ""],
            ["bound_phrase", "''",    "''",    "<i>",                "</i>",     "",     ""],
            ["bound_phrase", "^^",    "^^",    "<sup>",              "</sup>",   "",     ""],
            ["bound_phrase", "_-",    "_-",    "<sub>",              "</sub>",   "",     ""],
            ["bound_phrase", "}}",    "}}",    "<big>",              "</big>",   "",     ""],
            ["bound_phrase", "{{",    "{{",    "<small>",            "</small>", "",     ""]
        ];
        
        // Looping over all_tags
        for (i = 0; i < all_tags.length; i++)
        {
            if (all_tags[i][0].toLowerCase() == "line_alone")
            {
                html = this.replace_line(html, all_tags[i][1], all_tags[i][3] + all_tags[i][5] + all_tags[i][6] + all_tags[i][4]);
            }
        }
        
        for (i = 0; i < all_tags.length; i++)
        {
            if ((all_tags[i][0].toLowerCase() == "start_lines") || (all_tags[i][0].toLowerCase() == "start_line"))
            {
                html = this.markup_lines(html, all_tags[i][1], all_tags[i][3], all_tags[i][4], all_tags[i][5], all_tags[i][6]);
            }
        }
        
        for (i = 0; i < all_tags.length; i++)
        {
            if (all_tags[i][0].toLowerCase() == "bound_phrase")
            {
                html = this.replace_bounds(html, all_tags[i][1], all_tags[i][2], all_tags[i][3], all_tags[i][4], all_tags[i][5], all_tags[i][6]);
            }
        }

        html = this.pack_paragraphs(html);
        html = this.create_tables(html);
        
        //////////////// LISTEN KAPUTT UND MEHR ////////////////////
        alert(html);

        return html;        
    }
    
    // Subclassing Wysiwig in order to make WikiBerd-specific WikiTags come alive
    proto2 = Subclass("Wikiwyg.Wysiwyg.ewiki", "Wikiwyg.Wysiwyg");
    
    proto2.do_sup   = function(command)
    {
        this.exec_command('superscript', '');
    }
    
    proto2.do_sub   = function(command)
    {
        this.exec_command('subscript', '');
    }
    
    proto2.do_normal = function(command)
    {
        this.exec_command("fontsize", "3");
    }
    
    proto2.do_big   = function(command)
    {
        this.exec_command("fontsize","5");
    }
    
    proto2.do_small = function(command)
    {
        this.exec_command("fontsize","2");
    }
    
    // Configuring Wikiwyg
    var ewiki_div = document.getElementById("div_wikiwyg");

    var ewiki_config =
    {
        javascriptLocation: "Wikiwyg/",
        doubleClickToEdit: true,
        supportCamelCaseLinks: true,
    
        toolbar:
        {
            imagesLocation: "Wikiwyg/images/",
                
            controlLayout:
            [
                "mode_selector", "/",
                "h1", "h2", "h3", "p", "pre", "|", // "big", "small", "|",
                "selector", "|",
                "bold", "italic", "underline", "strike", "sub", "sup", "|",
                "ordered", "unordered", "circlelist", "squarelist", "|",
                "table", "hr"
            ],
            
            styleSelector:
            [
                "size", "normal", "big", "small"
            ],
            
            controlLabels:
            {
                save: "Save",
                cancel: "Cancel",
                bold: "Bold (ctl-b)",
                italic: "Italic (ctl-i)",
                underline: "Underline (ctl-u)",
                strike: "Strike Through (ctl-d)",
                hr: "Horizontal Rule",
                ordered: "Numbered List",
                unordered: "Bulleted List (Discs)",
                circlelist: "Bulleted List (Circles)",
                squarelist: "Bulleted List (Squares)",
                indent: "More Indented",
                outdent: "Less Indented",
                help: "About Wikiwyg",
                label: "[Style]",
                p: "Standard paragraph",
                pre: "Preformatted",
                h1: "Heading 1",
                h2: "Heading 2",
                h3: "Heading 3",
                h4: "Heading 4",
                h5: "Heading 5",
                h6: "Heading 6",
                size: "[Size]",
                normal: "Normal",
                big: "Big",
                small: "Small",
                sup: "Superscript",
                sub: "Subscript",
                link: "Create Link",
                table: "Create Table"
            }
        },
        
        wysiwyg:
        {
            iframeId: "iframe_wikiwyg"
        }
    };

    // Displaying Wikiwyg    
    wikiwyg1 = new Wikiwyg.ewiki();
    wikiwyg1.createWikiwygArea(ewiki_div, ewiki_config);
    
    // If we're too fast the iframe is not ready yet and ends up unusable!
    setTimeout("wikiwyg1.editMode()", 1000);
}

function ewiki_NormalTextarea()
{
    if (WikiwygHasBeenVisible)
    {
        // Update textarea with content from Wikiwyg
        wikiwyg1.onSubmit();
    }
    
    document.getElementById("div_wikiwyg_textarea").style.display = "none";
    document.getElementById("div_content_textarea").style.display = "block";
    
    document.getElementById("ewiki_wikiwyg_info1").style.display = "none";
    document.getElementById("ewiki_wikiwyg_info2").style.display = "block";
    
    normalTextarea = true;
}

function ewiki_ExtendedTextarea()
{
    if (! Wikiwyg.browserIsSupported) { return; }

    // Update Wikiwyg with text from ewiki's textarea
    wikiwyg1.fromWikiText(document.getElementById("ewiki_content").value);

    document.getElementById("div_wikiwyg_textarea").style.display = "block";
    document.getElementById("div_content_textarea").style.display = "none";

    document.getElementById("ewiki_wikiwyg_info1").style.display = "block";
    document.getElementById("ewiki_wikiwyg_info2").style.display = "none";

    normalTextarea = false;
}

