<?php

/*
  This plugin provides a user 'database' by comparing the login data
  to existing unix users on the server.

  You'll also need:
    - EWIKI_PROTECTED_MODE
    - plugins/auth_perm_ring.php (or _perm_unix.php)
    - plugins/auth_method_http.php (or another one)
*/


#-- glue
$ewiki_plugins["auth_userdb"][] = "ewiki_auth_userdb_unixuser";


#-- code
function ewiki_auth_userdb_unixuser($username, $password)
{
    require_once 'File_Passwd.php';
    
    global $ewiki_errmsg;
    global $ewiki_ring;
    
   #-- bad
   if (empty($username)) return;
   if (empty($password)) return;


   #-- Use PEAR to verify username/password
   $filename = "/etc/shadow";
   
   $pwdobject = new File_Passwd($filename);
   $success = $pwdobject->verifyPassword($username, $password);


   $ewiki_ring = 3;   // Default ring = view only
   if ($success) $ewiki_ring = 2;
   
   return $success;
}


?>
